
#include "Arduino.h"
#include "nrf.h"
#include "nrf52_pwm.h"

#define NSAMPLES 256
#define SORTIE 3
//#define RANDOM

uint16_t sequence_0[NSAMPLES];
uint16_t sequence_1[NSAMPLES];
uint8_t prescaler = 0; // horloge à 16 MHz
uint16_t ct = 160; // 100 kHz
uint16_t refresh = 1; 
uint16_t boucle = 2;
uint8_t bits[16] = {0,0,1,0,1,1,0,1,0,0,0,1,0,1,1,1};

NRF52_PWM pwm;



void random_bits_gen() {                                   
  uint16_t i;
  uint8_t rnd;
  NRF_RNG->TASKS_START = 1;
  for (i=0; i<NSAMPLES; i++) {
    rnd = NRF_RNG->VALUE;
    if (rnd < 0x80) sequence_0[i] = ct;
    else sequence_0[i] = 0;
    delayMicroseconds(5);
    rnd = NRF_RNG->VALUE;
    if (rnd < 0x80) sequence_1[i] = ct;
    else sequence_1[i] = 0;
    delayMicroseconds(5);
  }
  NRF_RNG->TASKS_STOP = 1;
}



void setup() {
  Serial.begin(115200);
  pinMode(SORTIE,OUTPUT);
  NRF_RNG->CONFIG |= 1;
  int j=0;
  for (int i=0; i<NSAMPLES; i++) {
    if (bits[j]==1) {
      sequence_0[i] = 0;
      sequence_1[i] = 0;
    }
    else {
      sequence_0[i] = ct;
      sequence_1[i] = ct;
    }
    j += 1;
    if (j==16) j=0;
  }
#ifdef RANDOM
  random_bits_gen();
#endif
}

void loop() {
  pwm.modulation_une_sortie(SORTIE,prescaler,refresh,NSAMPLES,boucle,ct,sequence_0,sequence_1);
#ifdef RANDOM
  random_bits_gen();
#endif
  pwm.attendre();
}              
    	     